# 4.2 简单的数学运算

数学运算是非常有用的功能，现实中会经常用到，比如：计算商品总价、学生的平均成绩、个人所得税等等。

# 4.2.1 数字

在了解数学运算之前，让我们先简单的了解一下`变量`和`数字`，更改上一小节的HelloWorld程序:

```rust
fn main(){
    let x = 5;
    println!("{}", x);
}
```

运行这个程序，将会打印出数字5，在这个程序中：

- let 表示定义一个**变量**, 变量名叫x
- = 符号 表示给 x **赋值**, 并且值为5
- 5 是一个`数字`, Rust会自动把它当成一个**整数**处理
- println!("{}", x) 是格式化输出语句，{}是一个占位符，它表示后面的变量x的值会嵌入这里，也就是打印x的值(这里大致了解一下就行，后续章节会有详细讲解)

# 4.2.2 简单的数学运算

我们可以对数字进行加减乘除运算：

```rust
fn main(){
    let x = 5 + 10;
    println!("{}", x);
}
```

以上程序将输出15, 也就是5+10的结果。当然我们也可以对变量做运算，以下程序的输出结果是一样的：

```rust
fn main(){
    let x = 5;
    let y = 10;
    let z = x + y;
    println!("{}", z);
}
```

除了加法，我们还可以做更多别的运算, 以下是常用的四则运算：

| 运算 | 符号 | 示例  |
| --- |:---:| ---:|
| 加 | + | 10 + 5 |
| 减 | - | 10 - 5 |
| 乘 | * | 10 * 5 |
| 除 | / | 10 / 5 |


# 4.2.3 整数和浮点数

上述例子的`let x = 5;`中, 5会当成一个整数, 正整数是没有小数部分的, 例如:

```rust
fn main(){
    println!("{}", 5 / 10);
}
```

这个程序打印出 5/10 的运算结果是0, 而不是0.5！ 因为**两个整数的除法运算结果也是整数**

如果希望得到比较精确的结果, 我们需要使用浮点数:

```rust
fn main(){
    println!("{}", 5.0 / 10.0);
}
```

这个程序会输出0.5, 这里的`5.0`和`10.0`因为带小数点，所以会被当成浮点数处理, 而浮点数的除法可以得到比较精确的结果
